//EnvoyerBlocDerriereAutre_401f.js
// 19.01.09 / Hans Haesler, Chtelard 52, CH-1018 Lausanne / <hsa@ringier.ch>
//Ce script sert  envoyer le premier bloc slectionn derrire 
//le second bloc slectionn

// tester si deux blocs sont slectionns
if (app.documents.length == 0) {
	alert ("Ouvre un document, slectionne deux blocs et essaie encore.", "Attention");
	exit();
}

if (app.selection.length < 2) {
	alert ("Il faut slectionner deux blocs\net relancer le script.", "Stop");
	exit();
}
else if (app.selection.length > 2) {
	alert ("Il ne faut slectionner\nque *deux* blocs  la fois.", "Stop");
	exit();
}

// mmoriser la slection
var curSel = app.selection;
var actSpread = app.activeWindow.activeSpread;

// mmoriser les 'id' des deux objets
var id1 = curSel[0].id;
var id2 = curSel[1].id;

// dresser la liste des objets de page
var idList = actSpread.pageItems.everyItem().id;

// initialiser des variables
var nItems = idList.length;
var idTop = idList[0];
var topItem = actSpread.pageItems[0];
var idBot = idList[nItems-1];

// si l'objet 'id1' est le dernier de la liste 'idList' on peut 
// envoyer l'objet 'id2' en arrire-plan (et vice versa).
if (id1 == idBot) {
	curSel[1].sendToBack();
}
else if (id2 == idBot) {
	curSel[0].sendToBack();
}

// si l'objet 'id1' est le premier de la liste 'idList' et 'id2' 
// est le second, il faut amener celui-ci au premier plan
else {
	if (id1 == idTop) {
		if (id2 == idList[1]) {
			actSpread.pageItems[1].bringToFront();
		}
		// sinon il faut faire une boucle  travers la liste afin de trouver 
		// la position de l'objet
		else {
			for (i=0; i<nItems; i++) {
				if (idList[i] == id2) {
					var itPos = i;
					break;
				}
			}
			// ensuite, on fait un groupe temporaire du deuxime objet de page 
			// jusqu' l'objet dont on a mmorise la position, ce groupe est plac 
			// en premier plan et il est dgroup
			try {
				var tmpGroup = actSpread.groups.add(actSpread.pageItems.itemByRange(1, itPos));
				tmpGroup.bringToFront();
				tmpGroup.ungroup();
			}
			catch (e) {
			}
		}
	}
	// ci-aprs, ce sont les mmes oprations dans le cas o c'est l'autre bloc 
	// qui se trouve au premier plan
	else if (id2 == idTop) {
		if (id1 == idList[1]) {
			actSpread.pageItems[1].bringToFront();
		}
		else {
			for (i=0; i<nItems; i++) {
				if (idList[i] == id1) {
					var itPos = i;
					break;
				}
			}
			try {
				var tmpGroup = actSpread.groups.add(actSpread.pageItems.itemByRange(1, itPos));
				tmpGroup.bringToFront();
				tmpGroup.ungroup();
			}
			catch (e) {
			}
		}
	}
	// sinon il faut parcourir la liste 'idList'  la recherche de la position 
	// de chacun des blocs
	else {
		for (i=0; i<nItems; i++) {
			if (idList[i] == id1) {
				var pos1 = i;
				break;
			}
		}
		for (i=0; i<nItems; i++) {
			if (idList[i] == id2) {
				var pos2 = i;
				break;
			}
		}
		// si la position 1 est infrieure  la seconde
		if (pos1 < pos2) {
			// et si la diffrence est plus grand que 1 ...
			if (pos2 - pos1 > 1) {
				// ... mais le premier bloc est le deuxime sur la pile, alors il faut 
				// faire un groupe temporaire, le mettre au premier plan, passer aussi l'objet 
				// isol au premier plan avant de dgrouper
				if (pos1 == 1) {
					var tmpGroup = actSpread.groups.add(actSpread.pageItems.itemByRange(2, pos2));
					tmpGroup.bringToFront();
					actSpread.pageItems[1].bringToFront();
					tmpGroup.ungroup();
				}
				else {
					var tmpGroup2 = actSpread.groups.add(actSpread.pageItems.itemByRange((pos1 + 1), pos2));
					var tmpGroup1 = actSpread.groups.add(actSpread.pageItems.itemByRange(0, (pos1 - 1)));
					tmpGroup2.bringToFront();
					tmpGroup1.bringToFront();
					tmpGroup1.ungroup();
					tmpGroup2.ungroup();
				}
			}
			// sinon on envoie le premier bloc en arrire
			else {
				actSpread.pageItems.item(pos1).sendBackward();
			}
		}
		// comme ci-dessus, mais avec des positions inverses
		else {
			if (pos1 - pos2 > 1) {
				if (pos2 == 1) {
					var tmpGroup = actSpread.groups.add(actSpread.pageItems.itemByRange(2, pos1));
					tmpGroup.bringToFront();
					actSpread.pageItems[1].bringToFront();
					tmpGroup.ungroup();
				}
				else {
					var tmpGroup2 = actSpread.groups.add(actSpread.pageItems.itemByRange((pos2 + 1), pos1));
					var tmpGroup1 = actSpread.groups.add(actSpread.pageItems.itemByRange(0, (pos2 - 1)));
					tmpGroup2.bringToFront();
					tmpGroup1.bringToFront();
					tmpGroup1.ungroup();
					tmpGroup2.ungroup();
				}
			}
			else {
				actSpread.pageItems.item(pos2).sendBackward();
			}
		}
	}
}